Index: dna-repository/src/test/java/org/jboss/dna/repository/RepositoryServiceTest.java
===================================================================
--- dna-repository/src/test/java/org/jboss/dna/repository/RepositoryServiceTest.java	(revision 702)
+++ dna-repository/src/test/java/org/jboss/dna/repository/RepositoryServiceTest.java	(working copy)
@@ -35,7 +35,6 @@
 import java.util.concurrent.TimeUnit;
 import org.jboss.dna.common.util.Logger;
 import org.jboss.dna.connector.federation.FederationException;
-import org.jboss.dna.graph.BasicExecutionContext;
 import org.jboss.dna.graph.DnaLexicon;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.connectors.RepositoryConnection;
@@ -68,7 +67,7 @@
     @Before
     public void beforeEach() throws Exception {
         MockitoAnnotations.initMocks(this);
-        context = new BasicExecutionContext();
+        context = new ExecutionContext();
         context.getNamespaceRegistry().register(DnaLexicon.Namespace.PREFIX, DnaLexicon.Namespace.URI);
         configSourceName = "configSource";
         configRepository = SimpleRepository.get("Configuration Repository");
Index: dna-repository/src/test/java/org/jboss/dna/repository/sequencers/SequencingServiceTest.java
===================================================================
--- dna-repository/src/test/java/org/jboss/dna/repository/sequencers/SequencingServiceTest.java	(revision 702)
+++ dna-repository/src/test/java/org/jboss/dna/repository/sequencers/SequencingServiceTest.java	(working copy)
@@ -28,15 +28,18 @@
 import static org.hamcrest.core.IsSame.sameInstance;
 import static org.junit.Assert.assertThat;
 import static org.junit.matchers.JUnitMatchers.hasItem;
+import java.io.IOException;
 import java.util.concurrent.TimeUnit;
 import javax.jcr.Node;
+import javax.jcr.RepositoryException;
 import javax.jcr.Session;
 import javax.jcr.observation.Event;
+import org.jboss.dna.common.SystemFailureException;
 import org.jboss.dna.common.jcr.AbstractJcrRepositoryTest;
 import org.jboss.dna.repository.observation.ObservationService;
 import org.jboss.dna.repository.services.ServiceAdministrator;
 import org.jboss.dna.repository.util.JcrExecutionContext;
-import org.jboss.dna.repository.util.MockJcrExecutionContext;
+import org.jboss.dna.repository.util.SessionFactory;
 import org.junit.After;
 import org.junit.Before;
 import org.junit.Test;
@@ -56,7 +59,17 @@
 
     @Before
     public void beforeEach() {
-        this.executionContext = new MockJcrExecutionContext(this, REPOSITORY_WORKSPACE_NAME);
+        SessionFactory sessionFactory = new SessionFactory() {
+            public Session createSession( String name ) throws RepositoryException {
+                assertThat(name, is(REPOSITORY_WORKSPACE_NAME));
+                try {
+                    return getRepository().login(getTestCredentials());
+                } catch (IOException e) {
+                    throw new SystemFailureException(e);
+                }
+            }
+        };
+        this.executionContext = new JcrExecutionContext(sessionFactory, REPOSITORY_WORKSPACE_NAME);
         this.sequencingService = new SequencingService();
         this.sequencingService.setExecutionContext(this.executionContext);
         this.observationService = new ObservationService(this.executionContext.getSessionFactory());
Index: dna-repository/src/test/java/org/jboss/dna/repository/sequencers/StreamSequencerAdapterTest.java
===================================================================
--- dna-repository/src/test/java/org/jboss/dna/repository/sequencers/StreamSequencerAdapterTest.java	(revision 702)
+++ dna-repository/src/test/java/org/jboss/dna/repository/sequencers/StreamSequencerAdapterTest.java	(working copy)
@@ -27,10 +27,12 @@
 import static org.hamcrest.core.IsSame.sameInstance;
 import static org.junit.Assert.assertThat;
 import static org.junit.Assert.fail;
+import static org.mockito.Mockito.mock;
 import java.io.ByteArrayInputStream;
 import java.io.InputStream;
 import java.util.Collections;
 import java.util.HashSet;
+import java.util.Iterator;
 import java.util.Set;
 import javax.jcr.Node;
 import javax.jcr.Session;
@@ -38,15 +40,13 @@
 import org.jboss.dna.common.collection.Problems;
 import org.jboss.dna.common.collection.SimpleProblems;
 import org.jboss.dna.common.jcr.AbstractJcrRepositoryTest;
-import org.jboss.dna.graph.properties.NamespaceRegistry;
 import org.jboss.dna.graph.properties.Path;
+import org.jboss.dna.graph.properties.Property;
 import org.jboss.dna.graph.sequencers.SequencerContext;
 import org.jboss.dna.graph.sequencers.SequencerOutput;
 import org.jboss.dna.graph.sequencers.StreamSequencer;
 import org.jboss.dna.repository.observation.NodeChange;
-import org.jboss.dna.repository.util.BasicJcrExecutionContext;
 import org.jboss.dna.repository.util.JcrExecutionContext;
-import org.jboss.dna.repository.util.JcrNamespaceRegistry;
 import org.jboss.dna.repository.util.JcrTools;
 import org.jboss.dna.repository.util.RepositoryNodePath;
 import org.jboss.dna.repository.util.SessionFactory;
@@ -71,6 +71,7 @@
     private JcrExecutionContext context;
     private String repositoryWorkspaceName = "something";
     private Problems problems;
+    private javax.jcr.Property sequencedProperty;
 
     @Before
     public void beforeEach() {
@@ -83,8 +84,7 @@
             }
         };
         problems = new SimpleProblems();
-        NamespaceRegistry registry = new JcrNamespaceRegistry(sessionFactory, "doesn't matter");
-        this.context = new BasicJcrExecutionContext(sessionFactory, registry, null, null);
+        this.context = new JcrExecutionContext(sessionFactory, "doesn't matter");
         this.sequencerOutput = new SequencerOutputMap(this.context.getValueFactories());
         final SequencerOutputMap finalOutput = sequencerOutput;
         this.streamSequencer = new StreamSequencer() {
@@ -400,4 +400,120 @@
         });
     }
 
+    @Test( expected = java.lang.AssertionError.class )
+    public void shouldNotAllowNullInputNode() throws Exception {
+        sequencer.createSequencerContext(null, sequencedProperty, context, problems);
+    }
+
+    @Test( expected = java.lang.AssertionError.class )
+    public void shouldNotAllowNullSequencedProperty() throws Exception {
+        startRepository();
+        session = getRepository().login(getTestCredentials());
+
+        Node input = tools.findOrCreateNode(session, "/a");
+        sequencer.createSequencerContext(input, null, context, problems);
+    }
+
+    @Test( expected = java.lang.AssertionError.class )
+    public void shouldNotAllowNullExecutionContext() throws Exception {
+        startRepository();
+        session = getRepository().login(getTestCredentials());
+
+        Node input = tools.findOrCreateNode(session, "/a");
+        sequencer.createSequencerContext(input, sequencedProperty, null, problems);
+    }
+
+    @Test
+    public void shouldProvideNamespaceRegistry() throws Exception {
+        startRepository();
+        session = getRepository().login(getTestCredentials());
+
+        this.sequencedProperty = mock(javax.jcr.Property.class);
+        Node input = tools.findOrCreateNode(session, "/a/b/c");
+        SequencerContext sequencerContext = sequencer.createSequencerContext(input, sequencedProperty, context, problems);
+        assertThat(sequencerContext.getNamespaceRegistry(), notNullValue());
+    }
+
+    @Test
+    public void shouldProvideValueFactories() throws Exception {
+        startRepository();
+        session = getRepository().login(getTestCredentials());
+
+        this.sequencedProperty = mock(javax.jcr.Property.class);
+        Node input = tools.findOrCreateNode(session, "/a/b/c");
+        SequencerContext sequencerContext = sequencer.createSequencerContext(input, sequencedProperty, context, problems);
+        assertThat(sequencerContext.getValueFactories(), notNullValue());
+    }
+
+    @Test
+    public void shouldProvidePathToInput() throws Exception {
+        startRepository();
+        session = getRepository().login(getTestCredentials());
+
+        this.sequencedProperty = mock(javax.jcr.Property.class);
+        Node input = tools.findOrCreateNode(session, "/a/b/c");
+        SequencerContext sequencerContext = sequencer.createSequencerContext(input, sequencedProperty, context, problems);
+        assertThat(sequencerContext.getInputPath(), is(context.getValueFactories().getPathFactory().create("/a/b/c")));
+    }
+
+    @Test
+    public void shouldNeverReturnNullInputProperties() throws Exception {
+        startRepository();
+        session = getRepository().login(getTestCredentials());
+
+        this.sequencedProperty = mock(javax.jcr.Property.class);
+        Node input = tools.findOrCreateNode(session, "/a/b/c");
+        SequencerContext sequencerContext = sequencer.createSequencerContext(input, sequencedProperty, context, problems);
+        assertThat(sequencerContext.getInputProperties(), notNullValue());
+        assertThat(sequencerContext.getInputProperties().isEmpty(), is(false));
+    }
+
+    @Test
+    public void shouldProvideInputProperties() throws Exception {
+        startRepository();
+        session = getRepository().login(getTestCredentials());
+
+        this.sequencedProperty = mock(javax.jcr.Property.class);
+        Node input = tools.findOrCreateNode(session, "/a/b/c");
+        input.setProperty("x", true);
+        input.setProperty("y", new String[] {"asdf", "xyzzy"});
+        SequencerContext sequencerContext = sequencer.createSequencerContext(input, sequencedProperty, context, problems);
+        assertThat(sequencerContext.getInputProperties(), notNullValue());
+        assertThat(sequencerContext.getInputProperties().isEmpty(), is(false));
+        assertThat(sequencerContext.getInputProperties().size(), is(3));
+        verifyProperty(sequencerContext,
+                       "jcr:primaryType",
+                       context.getValueFactories().getNameFactory().create("{http://www.jcp.org/jcr/nt/1.0}unstructured"));
+        verifyProperty(sequencerContext, "x", true);
+        verifyProperty(sequencerContext, "y", "asdf", "xyzzy");
+    }
+
+    @Test
+    public void shouldCreateSequencerContextThatProvidesMimeType() throws Exception {
+        startRepository();
+        session = getRepository().login(getTestCredentials());
+
+        this.sequencedProperty = mock(javax.jcr.Property.class);
+        Node input = tools.findOrCreateNode(session, "/a/b/c");
+        SequencerContext sequencerContext = sequencer.createSequencerContext(input, sequencedProperty, context, problems);
+        assertThat(sequencerContext.getMimeType(), is("text/plain"));
+    }
+
+    private void verifyProperty( SequencerContext context,
+                                 String name,
+                                 Object... values ) {
+        Property prop = context.getInputProperty(context.getValueFactories().getNameFactory().create(name));
+        assertThat(prop, notNullValue());
+        assertThat(prop.getName(), is(context.getValueFactories().getNameFactory().create(name)));
+        assertThat(prop.isEmpty(), is(false));
+        assertThat(prop.size(), is(values.length));
+        assertThat(prop.isMultiple(), is(values.length > 1));
+        assertThat(prop.isSingle(), is(values.length == 1));
+        Iterator<?> iter = prop.getValues();
+        for (Object val : values) {
+            assertThat(iter.hasNext(), is(true));
+            assertThat(iter.next(), is(val));
+        }
+    }
+
 }
Index: dna-repository/src/main/java/org/jboss/dna/repository/RepositoryLibrary.java
===================================================================
--- dna-repository/src/main/java/org/jboss/dna/repository/RepositoryLibrary.java	(revision 702)
+++ dna-repository/src/main/java/org/jboss/dna/repository/RepositoryLibrary.java	(working copy)
@@ -33,7 +33,6 @@
 import java.util.concurrent.locks.ReentrantReadWriteLock;
 import net.jcip.annotations.ThreadSafe;
 import org.jboss.dna.common.util.CheckArg;
-import org.jboss.dna.graph.BasicExecutionContextFactory;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.ExecutionContextFactory;
 import org.jboss.dna.graph.connectors.RepositoryConnection;
@@ -113,7 +112,7 @@
      * Create a new manager instance.
      */
     public RepositoryLibrary() {
-        this(new BasicExecutionContextFactory(), null);
+        this(new ExecutionContext(), null);
     }
 
     /**
@@ -123,7 +122,7 @@
      *        this manager; may be null if there is no delegate
      */
     public RepositoryLibrary( RepositoryConnectionFactory delegate ) {
-        this(new BasicExecutionContextFactory(), delegate);
+        this(new ExecutionContext(), delegate);
     }
 
     /**
Index: dna-repository/src/main/java/org/jboss/dna/repository/sequencers/SequencingService.java
===================================================================
--- dna-repository/src/main/java/org/jboss/dna/repository/sequencers/SequencingService.java	(revision 702)
+++ dna-repository/src/main/java/org/jboss/dna/repository/sequencers/SequencingService.java	(working copy)
@@ -21,7 +21,6 @@
  */
 package org.jboss.dna.repository.sequencers;
 
-import java.security.AccessControlContext;
 import java.util.ArrayList;
 import java.util.HashMap;
 import java.util.HashSet;
@@ -32,15 +31,12 @@
 import java.util.concurrent.Executors;
 import java.util.concurrent.RejectedExecutionException;
 import java.util.concurrent.TimeUnit;
-import java.util.concurrent.atomic.AtomicBoolean;
 import java.util.concurrent.atomic.AtomicLong;
 import javax.jcr.Node;
 import javax.jcr.Repository;
 import javax.jcr.RepositoryException;
 import javax.jcr.Session;
 import javax.jcr.observation.Event;
-import javax.security.auth.Subject;
-import javax.security.auth.login.LoginContext;
 import net.jcip.annotations.Immutable;
 import net.jcip.annotations.ThreadSafe;
 import org.jboss.dna.common.collection.SimpleProblems;
@@ -50,10 +46,6 @@
 import org.jboss.dna.common.util.CheckArg;
 import org.jboss.dna.common.util.HashCode;
 import org.jboss.dna.common.util.Logger;
-import org.jboss.dna.graph.mimetype.MimeTypeDetector;
-import org.jboss.dna.graph.properties.NamespaceRegistry;
-import org.jboss.dna.graph.properties.PropertyFactory;
-import org.jboss.dna.graph.properties.ValueFactories;
 import org.jboss.dna.repository.RepositoryI18n;
 import org.jboss.dna.repository.observation.NodeChange;
 import org.jboss.dna.repository.observation.NodeChangeListener;
@@ -62,9 +54,7 @@
 import org.jboss.dna.repository.services.AdministeredService;
 import org.jboss.dna.repository.services.ServiceAdministrator;
 import org.jboss.dna.repository.util.JcrExecutionContext;
-import org.jboss.dna.repository.util.JcrTools;
 import org.jboss.dna.repository.util.RepositoryNodePath;
-import org.jboss.dna.repository.util.SessionFactory;
 
 /**
  * A sequencing system is used to monitor changes in the content of {@link Repository JCR repositories} and to sequence the
@@ -524,10 +514,10 @@
                         assert outputPaths != null && outputPaths.size() != 0;
 
                         // Create a new execution context for each sequencer
-                        final Context executionContext = new Context(context);
                         final SimpleProblems problems = new SimpleProblems();
+                        JcrExecutionContext sequencerContext = context.clone();
                         try {
-                            sequencer.execute(node, propertyName, changedNode, outputPaths, executionContext, problems);
+                            sequencer.execute(node, propertyName, changedNode, outputPaths, sequencerContext, problems);
                         } catch (RepositoryException e) {
                             logger.error(e, RepositoryI18n.errorInRepositoryWhileSequencingNode, sequencerName, changedNode);
                         } catch (SequencerException e) {
@@ -539,7 +529,7 @@
                             } finally {
                                 // And always close the context.
                                 // This closes all sessions that may have been created by the sequencer.
-                                executionContext.close();
+                                sequencerContext.close();
                             }
                         }
                     }
@@ -555,138 +545,6 @@
         }
     }
 
-    protected class Context implements JcrExecutionContext {
-
-        protected final JcrExecutionContext delegate;
-        protected final SessionFactory factory;
-        private final Set<Session> sessions = new HashSet<Session>();
-        protected final AtomicBoolean closed = new AtomicBoolean(false);
-
-        protected Context( JcrExecutionContext context ) {
-            this.delegate = context;
-            final SessionFactory delegateSessionFactory = this.delegate.getSessionFactory();
-            this.factory = new SessionFactory() {
-
-                public Session createSession( String name ) throws RepositoryException {
-                    if (closed.get()) throw new IllegalStateException(RepositoryI18n.executionContextHasBeenClosed.text());
-                    Session session = delegateSessionFactory.createSession(name);
-                    recordSession(session);
-                    return session;
-                }
-            };
-        }
-
-        public synchronized void close() {
-            if (this.closed.get()) return;
-            this.closed.set(true);
-            for (Session session : sessions) {
-                if (session != null) session.logout();
-            }
-        }
-
-        /**
-         * {@inheritDoc}
-         * 
-         * @see org.jboss.dna.common.component.ClassLoaderFactory#getClassLoader(java.lang.String[])
-         */
-        public ClassLoader getClassLoader( String... classpath ) {
-            return delegate.getClassLoader(classpath);
-        }
-
-        /**
-         * {@inheritDoc}
-         * 
-         * @see org.jboss.dna.graph.ExecutionContext#getMimeTypeDetector()
-         */
-        public MimeTypeDetector getMimeTypeDetector() {
-            return delegate.getMimeTypeDetector();
-        }
-
-        /**
-         * {@inheritDoc}
-         * 
-         * @see org.jboss.dna.graph.ExecutionContext#getAccessControlContext()
-         */
-        public AccessControlContext getAccessControlContext() {
-            return delegate.getAccessControlContext();
-        }
-
-        /**
-         * {@inheritDoc}
-         * 
-         * @see org.jboss.dna.graph.ExecutionContext#getLoginContext()
-         */
-        public LoginContext getLoginContext() {
-            return delegate.getLoginContext();
-        }
-
-        /**
-         * {@inheritDoc}
-         */
-        public NamespaceRegistry getNamespaceRegistry() {
-            return this.delegate.getNamespaceRegistry();
-        }
-
-        /**
-         * {@inheritDoc}
-         */
-        public PropertyFactory getPropertyFactory() {
-            return this.delegate.getPropertyFactory();
-        }
-
-        /**
-         * {@inheritDoc}
-         */
-        public SessionFactory getSessionFactory() {
-            return this.factory;
-        }
-
-        /**
-         * {@inheritDoc}
-         * 
-         * @see org.jboss.dna.graph.ExecutionContext#getSubject()
-         */
-        public Subject getSubject() {
-            return this.delegate.getSubject();
-        }
-
-        /**
-         * {@inheritDoc}
-         */
-        public JcrTools getTools() {
-            return SequencingService.this.getExecutionContext().getTools();
-        }
-
-        /**
-         * {@inheritDoc}
-         */
-        public ValueFactories getValueFactories() {
-            return this.delegate.getValueFactories();
-        }
-
-        /**
-         * {@inheritDoc}
-         * 
-         * @see org.jboss.dna.graph.ExecutionContext#getLogger(java.lang.Class)
-         */
-        public Logger getLogger( Class<?> clazz ) {
-            return this.delegate.getLogger(clazz);
-        }
-
-        /**
-         * {@inheritDoc}
-         * 
-         * @see org.jboss.dna.graph.ExecutionContext#getLogger(java.lang.String)
-         */
-        public Logger getLogger( String name ) {
-            return this.delegate.getLogger(name);
-        }
-
-        protected synchronized void recordSession( Session session ) {
-            if (session != null) sessions.add(session);
-        }
-    }
-
     /**
      * The statistics for the system. Each sequencing system has an instance of this class that is updated.
      * 
Index: dna-repository/src/main/java/org/jboss/dna/repository/sequencers/StreamSequencerAdapter.java
===================================================================
--- dna-repository/src/main/java/org/jboss/dna/repository/sequencers/StreamSequencerAdapter.java	(revision 702)
+++ dna-repository/src/main/java/org/jboss/dna/repository/sequencers/StreamSequencerAdapter.java	(working copy)
@@ -21,26 +21,36 @@
  */
 package org.jboss.dna.repository.sequencers;
 
+import java.io.IOException;
 import java.io.InputStream;
 import java.math.BigDecimal;
 import java.util.Calendar;
+import java.util.Collections;
 import java.util.Date;
+import java.util.HashSet;
 import java.util.Set;
 import javax.jcr.Node;
 import javax.jcr.PathNotFoundException;
 import javax.jcr.Property;
+import javax.jcr.PropertyIterator;
+import javax.jcr.PropertyType;
 import javax.jcr.RepositoryException;
 import javax.jcr.Session;
+import javax.jcr.Value;
 import org.jboss.dna.common.collection.Problems;
 import org.jboss.dna.common.util.Logger;
+import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.properties.Binary;
 import org.jboss.dna.graph.properties.DateTime;
 import org.jboss.dna.graph.properties.Name;
 import org.jboss.dna.graph.properties.NamespaceRegistry;
 import org.jboss.dna.graph.properties.Path;
 import org.jboss.dna.graph.properties.PathFactory;
+import org.jboss.dna.graph.properties.ValueFactories;
+import org.jboss.dna.graph.sequencers.SequencerContext;
 import org.jboss.dna.graph.sequencers.StreamSequencer;
 import org.jboss.dna.repository.RepositoryI18n;
+import org.jboss.dna.repository.mimetype.MimeType;
 import org.jboss.dna.repository.observation.NodeChange;
 import org.jboss.dna.repository.util.JcrExecutionContext;
 import org.jboss.dna.repository.util.RepositoryNodePath;
@@ -103,7 +113,7 @@
         Throwable firstError = null;
         try {
             stream = sequencedProperty.getStream();
-            SequencerNodeContext sequencerContext = new SequencerNodeContext(input, sequencedProperty, execContext, problems);
+            SequencerContext sequencerContext = createSequencerContext(input, sequencedProperty, execContext, problems);
             this.streamSequencer.sequence(stream, output, sequencerContext);
         } catch (Throwable t) {
             // Record the error ...
@@ -288,4 +298,105 @@
         return null;
     }
 
+    protected SequencerContext createSequencerContext( Node input,
+                                                       Property sequencedProperty,
+                                                       ExecutionContext context,
+                                                       Problems problems ) throws RepositoryException {
+        assert input != null;
+        assert sequencedProperty != null;
+        assert context != null;
+        assert problems != null;
+        // Translate JCR path and property values to DNA constructs and cache them to improve performance and prevent
+        // RepositoryException from being thrown by getters
+        // Note: getMimeType() will still operate lazily, and thus throw a SequencerException, since it is very intrusive and
+        // potentially slow-running.
+        ValueFactories factories = context.getValueFactories();
+        Path path = factories.getPathFactory().create(input.getPath());
+        Set<org.jboss.dna.graph.properties.Property> props = new HashSet<org.jboss.dna.graph.properties.Property>();
+        for (PropertyIterator iter = input.getProperties(); iter.hasNext();) {
+            javax.jcr.Property jcrProp = iter.nextProperty();
+            org.jboss.dna.graph.properties.Property prop;
+            if (jcrProp.getDefinition().isMultiple()) {
+                Value[] jcrVals = jcrProp.getValues();
+                Object[] vals = new Object[jcrVals.length];
+                int ndx = 0;
+                for (Value jcrVal : jcrVals) {
+                    vals[ndx++] = convert(factories, jcrProp.getName(), jcrVal);
+                }
+                prop = context.getPropertyFactory().create(factories.getNameFactory().create(jcrProp.getName()), vals);
+            } else {
+                Value jcrVal = jcrProp.getValue();
+                Object val = convert(factories, jcrProp.getName(), jcrVal);
+                prop = context.getPropertyFactory().create(factories.getNameFactory().create(jcrProp.getName()), val);
+            }
+            props.add(prop);
+        }
+        props = Collections.unmodifiableSet(props);
+        String mimeType = getMimeType(sequencedProperty, path.getLastSegment().getName().getLocalName());
+        return new SequencerContext(context, path, props, mimeType, problems);
+    }
+
+    protected Object convert( ValueFactories factories,
+                              String name,
+                              Value jcrValue ) throws RepositoryException {
+        switch (jcrValue.getType()) {
+            case PropertyType.BINARY: {
+                return factories.getBinaryFactory().create(jcrValue.getStream());
+            }
+            case PropertyType.BOOLEAN: {
+                return factories.getBooleanFactory().create(jcrValue.getBoolean());
+            }
+            case PropertyType.DATE: {
+                return factories.getDateFactory().create(jcrValue.getDate());
+            }
+            case PropertyType.DOUBLE: {
+                return factories.getDoubleFactory().create(jcrValue.getDouble());
+            }
+            case PropertyType.LONG: {
+                return factories.getLongFactory().create(jcrValue.getLong());
+            }
+            case PropertyType.NAME: {
+                return factories.getNameFactory().create(jcrValue.getString());
+            }
+            case PropertyType.PATH: {
+                return factories.getPathFactory().create(jcrValue.getString());
+            }
+            case PropertyType.REFERENCE: {
+                return factories.getReferenceFactory().create(jcrValue.getString());
+            }
+            case PropertyType.STRING: {
+                return factories.getStringFactory().create(jcrValue.getString());
+            }
+            default: {
+                throw new RepositoryException(RepositoryI18n.unknownPropertyValueType.text(name, jcrValue.getType()));
+            }
+        }
+    }
+
+    @SuppressWarnings( "null" )
+    // The need for the SuppressWarnings looks like an Eclipse bug
+    protected String getMimeType( Property sequencedProperty,
+                                  String name ) {
+        SequencerException err = null;
+        String mimeType = null;
+        InputStream stream = null;
+        try {
+            stream = sequencedProperty.getStream();
+            mimeType = MimeType.of(name, stream);
+            return mimeType;
+        } catch (Exception error) {
+            err = new SequencerException(error);
+        } finally {
+            if (stream != null) {
+                try {
+                    stream.close();
+                } catch (IOException error) {
+                    // Only throw exception if an exception was not already thrown
+                    if (err == null) err = new SequencerException(error);
+                }
+            }
+        }
+        if (err != null) throw err;
+        return mimeType;
+    }
 }
